<h2>If you previously run v1.5.0 and below, please delete the Gsix.MultiCraft.cfg file from the config folder.</h2>

## MultiCraft
<a href="https://www.nexusmods.com/valheim/mods/263?tab=description">A complete re-write from MultiCraft by Maximiliano Degue</a><br>

I posted under my own banner but credit goes to the original author. <br>

A mod that changes the crafting button to craft multiple amount at one click.<br>


## Installation (manual)
Place the unzipped content, <i>GsiX.MultiCraft</i> folder into your <i>"..\game install dir\BepInEx\plugin\ "</i> folder.


## Features
- The plugin will automatically look for the craft from container plugin.<br>
- The maximum craftable is capped at the maximum available resources.<br>
- Total resources from the craft from container and player inventory included.<br>
- User center message announce the total maximum craftable amount, zero otherwise.<br>
- Pause button to stop the crafting incase user set the crafting duration beyond clickable speed.<br>
- Project Auga Support. Contact the author for controller support.<br>
- ItemDrawers emulation config support.<br>
- Valheim+ partial support has been hardcoded. Container search logic can't be synchronize.<br>
- Aedenthorn's CraftFromContainer has been hardcoded. Confing fully sync.<br>


## Craft From Container Auto Config
<b>ExtendedContainerGUID</b> - The name of the craft from container plugin.<br>
<b>ExtendedContainerSection</b> - in which section the config are in. Usually in General.<br>
<b>ExtendedContainerKey</b> - the actual 'config name' of the craft from container RANGE config.<br>
<b>ShowRequiredBelowIcon</b> - On by default. If you having an issue with the required/avilable number shown below the rquirement Icon, set this to 'false'<br>
** Note: If the plugin failed to detect your craft from container setting, please manually set the max Container RANGE in the emulation below.<br>


## Craft From Container Emulation Config
** Please note that this is only emulation to mimic your craft from container behavior.<br>
** It does not do the craft from container logic.<br>

AlternateContainerRange << Your craft from container range value<br>
AllowContainers_Ship << Is your craft from container allow pulling resources from Ship.<br>
AllowContainers_Wagon << Is your craft from container allow pulling resources from Wagon/Cart.<br>
AllowContainers_Wood << Is your craft from container allow pulling resources from Wooden chest.<br>
AllowContainers_Reinforced << Is your craft from container allow pulling resources from Iron chest.<br>
AllowContainers_BlackMetal << Is your craft from container allow pulling resources from Blackmetal chest.<br>
AllowContainers_PersonalChest << Is your craft from container allow pulling resources from Personal chest.<br>
AllowContainers_YuleklappChest << Is your craft from container allow pulling resources from Yuleklapp chest.<br>
AllowContainers_ItemDrawer << Is your craft from container allow pulling resources from ItemDrawers chest.<br>
AllowContainers_Warded << Is your craft from container allow pulling resources from warded chest.<br>
AllowContainers_InUse << Is your craft from container allow pulling resources from container being use.<br>


<details>
    <summary>Click To View Full Config</summary>
    <span>
			DeveloperConsole << Allow Developer console output. You dont need this.<br>
            PluginEnable << Plugin Enabled/Disabled<br>
            ShowMaxCraftable << Show maximum craftable amount at center text<br>
            CraftingDuration << Crafting time. 2f is ingame default value<br>
            CapMaximumCraftable << If true, maximum craftable capped at maximum amount of resources.<br>
            ShowIconRequirement << If true, maximum required amount will be shown in individual requirement icon, this may cause issue for other plugin that read the value in real-time. Try turn it to false<br>
			<br>
            ExtendedContainerGUID << Name of the Craft from container plugin GUID<br>
            ExtendedConfigSection << Name of the config section where we retrive the value<br>
            ExtendedConfigKeys << Name of the config key we try to retrive the value<br>
			<br>
            AlternateContainerRange << Alternate manual Container range config.<br>
            AllowContainers_Ship << Emulate allow Ship container to pull resources<br>
            AllowContainers_Wagon << Emulate allow Wagon container to pull resources<br>
            AllowContainers_Wood << Emulate allow Wooden Container to pull resources<br>
            AllowContainers_Reinforced << Emulate allow Reinforced Container to pull resources<br>
            AllowContainers_BlackMetal << Emulate allow Black Metal Container to pull resources<br>
            AllowContainers_PersonalChest << Emulate allow Personal Chest to pull resources<br>
            AllowContainers_YuleklappChest << Emulate allow Yuleklapp Chest to pull resources<br>
            AllowContainers_ItemDrawer << Emulate allow ItemDrawers Chest to pull resources<br>
            AllowContainers_Warded << Emulate allow Warded Container to pull resources<br>
            AllowContainers_InUse << Emulate allow container being use by player to pull resources<br>
	</span>
</details>

## Keyboard
- <b>Hold left Shift</b> +10/-10 crafting amount. Capped by the maximum craftable resources.<br>
- <b>Hold left Ctrl</b> +100/-100 crafting amount. Capped by the maximum craftable resources.<br>
<a href="https://docs.unity3d.com/ScriptReference/KeyCode.html">Keyboard Shortcut Key List</a><br>


## Gamepad/Controller:	
- <b>A + DPad Right</b> +10 amount
- <b>A + DPad Left</b> -10 amount
- <b>R Stick + DPad Right</b> +100 amount
- <b>R Stick + DPad Left</b> -100 amount<br>
<a href="https://valheim-modding.github.io/Jotunn/data/input/input-list.html">GamePad/Controller Shortcut Key List</a><br>


## Known issues
- Multiple player simultaneously crafting may not show the updated actual maximum amount in real time.<br>
- Valheim+ server config sync still not possible. Valheim+ local and sever config must be sync manually.<br>
- Opening and closing the player inventory multiple times causing the MultiCraft and Craft From container plugin out of sync. Known issue come from Craft From Container plugin.<br>
- Valheim+ Warded chest and item consumed/used up, icon dosen't get updated in realtime while MultiCraft does.<br>
Please report at Nexus page. Link at the bottom.<br>


## Changelog
<details>
    <summary>Click To View Changelog</summary>
    <span>
		- 1.0.0 - Public release.<br>
		- 1.0.1 - Crafting continue when selecting other recipe. Blocked recipe selection during crafting.<br>
		- 1.1.1 - Added Controller support.<br>
		- 1.1.2 - Thunderstore readme fix.<br>
		- 1.2.2 - Added Craft From Container emulation (Ongoing Beta Test).<br>
		- 1.2.3 - On going Beta Test for Craft From Continer emulation.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Transition between keyboard and controller during crafting dosen't show the right button layout.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Craft button not showing correct length when opening the menu using controller.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Stop current craft progress if recepie changes.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Configureable Keyboard shortcut.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Configureable Gamepad shortcut.<br>
		- 1.2.4 - Raw Fish crafting fix.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; New emulation config, allow continer inuse by player.<br>
		- 1.2.5 - Thunderstore readme fix.<br>
		- 1.2.6 - Upgrade tab fix.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Upgrading move back to Crafting tab fix.<br>
		- 1.3.0 - Project Auga compatibility. No Joystic/Controller support. Contact the author fo that.<br>
		- 1.4.0 - Displaying max amount at crafting button.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Joypad/Controller update.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Selecting same recipe dosent update max amount fix.<br>
		- 1.4.1 - Update 8-Nov-23.<br>
		- 1.5.0 - ItemsDrawer container emulation.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Allow yuleklapp container config<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Developer container name console output.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; No Build Cost text.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Unblock craftable amount if no cost debugmode trigged.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Button creation on player awake.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Resources fullfilled but other requirement is not, amount in grey color.<br>
		- 1.6.0 - Custom support has been hardcoded.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Pulling resources from Cart fix.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Pulling resources from ship fix.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Pulling resources from warded fix. V+ warded logic broken.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Crafting amount reset back to 1 if maximum craftable still above 0<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Minus amount stay at minimum number 1 if maximum craftable still above 0<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Aedenthorn's CraftFromContainers config read from chainloader.<br>
		&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; Valheim plus config read from client config. Server sync still not possible.<br>
	</span>
</details>



## Comment and bug report
<a href="https://www.nexusmods.com/valheim/mods/2588">Link to Nexus Home Page</a>